<a id="mypy-boto3-alexaforbusiness"></a>

# mypy-boto3-alexaforbusiness

[![PyPI - mypy-boto3-alexaforbusiness](https://img.shields.io/pypi/v/mypy-boto3-alexaforbusiness.svg?color=blue)](https://pypi.org/project/mypy-boto3-alexaforbusiness)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-alexaforbusiness.svg?color=blue)](https://pypi.org/project/mypy-boto3-alexaforbusiness)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-alexaforbusiness?color=blue)](https://pypistats.org/packages/mypy-boto3-alexaforbusiness)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.AlexaForBusiness 1.26.0](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/alexaforbusiness.html#AlexaForBusiness)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.11.10](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-alexaforbusiness docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_alexaforbusiness/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-alexaforbusiness](#mypy-boto3-alexaforbusiness)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `AlexaForBusiness`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `AlexaForBusiness` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[alexaforbusiness]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[alexaforbusiness]'


# standalone installation
python -m pip install mypy-boto3-alexaforbusiness
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-alexaforbusiness
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[alexaforbusiness]` in your environment:

```bash
python -m pip install 'boto3-stubs[alexaforbusiness]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[alexaforbusiness]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[alexaforbusiness]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[alexaforbusiness]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[alexaforbusiness]` with services you use in your
  environment:

```bash
python -m pip install 'boto3-stubs[alexaforbusiness]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[alexaforbusiness]` in your environment:

```bash
python -m pip install 'boto3-stubs[alexaforbusiness]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[alexaforbusiness]` in your environment:

```bash
python -m pip install 'boto3-stubs[alexaforbusiness]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`AlexaForBusinessClient` provides annotations for
`boto3.client("alexaforbusiness")`.

```python
from boto3.session import Session

from mypy_boto3_alexaforbusiness import AlexaForBusinessClient

client: AlexaForBusinessClient = Session().client("alexaforbusiness")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_alexaforbusiness.paginator` module contains type annotations for
all paginators.

```python
from boto3.session import Session

from mypy_boto3_alexaforbusiness import AlexaForBusinessClient
from mypy_boto3_alexaforbusiness.paginator import (
    ListBusinessReportSchedulesPaginator,
    ListConferenceProvidersPaginator,
    ListDeviceEventsPaginator,
    ListSkillsPaginator,
    ListSkillsStoreCategoriesPaginator,
    ListSkillsStoreSkillsByCategoryPaginator,
    ListSmartHomeAppliancesPaginator,
    ListTagsPaginator,
    SearchDevicesPaginator,
    SearchProfilesPaginator,
    SearchRoomsPaginator,
    SearchSkillGroupsPaginator,
    SearchUsersPaginator,
)

client: AlexaForBusinessClient = Session().client("alexaforbusiness")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_business_report_schedules_paginator: ListBusinessReportSchedulesPaginator = (
    client.get_paginator("list_business_report_schedules")
)
list_conference_providers_paginator: ListConferenceProvidersPaginator = client.get_paginator(
    "list_conference_providers"
)
list_device_events_paginator: ListDeviceEventsPaginator = client.get_paginator("list_device_events")
list_skills_paginator: ListSkillsPaginator = client.get_paginator("list_skills")
list_skills_store_categories_paginator: ListSkillsStoreCategoriesPaginator = client.get_paginator(
    "list_skills_store_categories"
)
list_skills_store_skills_by_category_paginator: ListSkillsStoreSkillsByCategoryPaginator = (
    client.get_paginator("list_skills_store_skills_by_category")
)
list_smart_home_appliances_paginator: ListSmartHomeAppliancesPaginator = client.get_paginator(
    "list_smart_home_appliances"
)
list_tags_paginator: ListTagsPaginator = client.get_paginator("list_tags")
search_devices_paginator: SearchDevicesPaginator = client.get_paginator("search_devices")
search_profiles_paginator: SearchProfilesPaginator = client.get_paginator("search_profiles")
search_rooms_paginator: SearchRoomsPaginator = client.get_paginator("search_rooms")
search_skill_groups_paginator: SearchSkillGroupsPaginator = client.get_paginator(
    "search_skill_groups"
)
search_users_paginator: SearchUsersPaginator = client.get_paginator("search_users")
```

<a id="literals"></a>

### Literals

`mypy_boto3_alexaforbusiness.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_alexaforbusiness.literals import (
    BusinessReportFailureCodeType,
    BusinessReportFormatType,
    BusinessReportIntervalType,
    BusinessReportStatusType,
    CommsProtocolType,
    ConferenceProviderTypeType,
    ConnectionStatusType,
    DeviceEventTypeType,
    DeviceStatusDetailCodeType,
    DeviceStatusType,
    DeviceUsageTypeType,
    DistanceUnitType,
    EnablementTypeFilterType,
    EnablementTypeType,
    EndOfMeetingReminderTypeType,
    EnrollmentStatusType,
    FeatureType,
    ListBusinessReportSchedulesPaginatorName,
    ListConferenceProvidersPaginatorName,
    ListDeviceEventsPaginatorName,
    ListSkillsPaginatorName,
    ListSkillsStoreCategoriesPaginatorName,
    ListSkillsStoreSkillsByCategoryPaginatorName,
    ListSmartHomeAppliancesPaginatorName,
    ListTagsPaginatorName,
    LocaleType,
    NetworkEapMethodType,
    NetworkSecurityTypeType,
    PhoneNumberTypeType,
    RequirePinType,
    SearchDevicesPaginatorName,
    SearchProfilesPaginatorName,
    SearchRoomsPaginatorName,
    SearchSkillGroupsPaginatorName,
    SearchUsersPaginatorName,
    SipTypeType,
    SkillTypeFilterType,
    SkillTypeType,
    SortValueType,
    TemperatureUnitType,
    WakeWordType,
    AlexaForBusinessServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: BusinessReportFailureCodeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_alexaforbusiness.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_alexaforbusiness.type_defs import (
    AddressBookDataTypeDef,
    AddressBookTypeDef,
    ApproveSkillRequestRequestTypeDef,
    AssociateContactWithAddressBookRequestRequestTypeDef,
    AssociateDeviceWithNetworkProfileRequestRequestTypeDef,
    AssociateDeviceWithRoomRequestRequestTypeDef,
    AssociateSkillGroupWithRoomRequestRequestTypeDef,
    AssociateSkillWithSkillGroupRequestRequestTypeDef,
    AssociateSkillWithUsersRequestRequestTypeDef,
    AudioTypeDef,
    BusinessReportContentRangeTypeDef,
    BusinessReportRecurrenceTypeDef,
    BusinessReportS3LocationTypeDef,
    CategoryTypeDef,
    ConferencePreferenceTypeDef,
    IPDialInTypeDef,
    MeetingSettingTypeDef,
    PSTNDialInTypeDef,
    PhoneNumberTypeDef,
    SipAddressTypeDef,
    SsmlTypeDef,
    TextTypeDef,
    TagTypeDef,
    ResponseMetadataTypeDef,
    CreateEndOfMeetingReminderTypeDef,
    CreateInstantBookingTypeDef,
    CreateRequireCheckInTypeDef,
    DeleteAddressBookRequestRequestTypeDef,
    DeleteBusinessReportScheduleRequestRequestTypeDef,
    DeleteConferenceProviderRequestRequestTypeDef,
    DeleteContactRequestRequestTypeDef,
    DeleteDeviceRequestRequestTypeDef,
    DeleteDeviceUsageDataRequestRequestTypeDef,
    DeleteGatewayGroupRequestRequestTypeDef,
    DeleteNetworkProfileRequestRequestTypeDef,
    DeleteProfileRequestRequestTypeDef,
    DeleteRoomRequestRequestTypeDef,
    DeleteRoomSkillParameterRequestRequestTypeDef,
    DeleteSkillAuthorizationRequestRequestTypeDef,
    DeleteSkillGroupRequestRequestTypeDef,
    DeleteUserRequestRequestTypeDef,
    DeveloperInfoTypeDef,
    DeviceEventTypeDef,
    DeviceNetworkProfileInfoTypeDef,
    DeviceStatusDetailTypeDef,
    DisassociateContactFromAddressBookRequestRequestTypeDef,
    DisassociateDeviceFromRoomRequestRequestTypeDef,
    DisassociateSkillFromSkillGroupRequestRequestTypeDef,
    DisassociateSkillFromUsersRequestRequestTypeDef,
    DisassociateSkillGroupFromRoomRequestRequestTypeDef,
    EndOfMeetingReminderTypeDef,
    FilterTypeDef,
    ForgetSmartHomeAppliancesRequestRequestTypeDef,
    GatewayGroupSummaryTypeDef,
    GatewayGroupTypeDef,
    GatewaySummaryTypeDef,
    GatewayTypeDef,
    GetAddressBookRequestRequestTypeDef,
    GetConferenceProviderRequestRequestTypeDef,
    GetContactRequestRequestTypeDef,
    GetDeviceRequestRequestTypeDef,
    GetGatewayGroupRequestRequestTypeDef,
    GetGatewayRequestRequestTypeDef,
    GetNetworkProfileRequestRequestTypeDef,
    NetworkProfileTypeDef,
    GetProfileRequestRequestTypeDef,
    GetRoomRequestRequestTypeDef,
    RoomTypeDef,
    GetRoomSkillParameterRequestRequestTypeDef,
    RoomSkillParameterTypeDef,
    GetSkillGroupRequestRequestTypeDef,
    SkillGroupTypeDef,
    InstantBookingTypeDef,
    PaginatorConfigTypeDef,
    ListBusinessReportSchedulesRequestRequestTypeDef,
    ListConferenceProvidersRequestRequestTypeDef,
    ListDeviceEventsRequestRequestTypeDef,
    ListGatewayGroupsRequestRequestTypeDef,
    ListGatewaysRequestRequestTypeDef,
    ListSkillsRequestRequestTypeDef,
    SkillSummaryTypeDef,
    ListSkillsStoreCategoriesRequestRequestTypeDef,
    ListSkillsStoreSkillsByCategoryRequestRequestTypeDef,
    ListSmartHomeAppliancesRequestRequestTypeDef,
    SmartHomeApplianceTypeDef,
    ListTagsRequestRequestTypeDef,
    RequireCheckInTypeDef,
    NetworkProfileDataTypeDef,
    ProfileDataTypeDef,
    PutInvitationConfigurationRequestRequestTypeDef,
    PutSkillAuthorizationRequestRequestTypeDef,
    RejectSkillRequestRequestTypeDef,
    ResolveRoomRequestRequestTypeDef,
    RevokeInvitationRequestRequestTypeDef,
    RoomDataTypeDef,
    SortTypeDef,
    SkillGroupDataTypeDef,
    UserDataTypeDef,
    SendInvitationRequestRequestTypeDef,
    StartDeviceSyncRequestRequestTypeDef,
    StartSmartHomeApplianceDiscoveryRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateAddressBookRequestRequestTypeDef,
    UpdateDeviceRequestRequestTypeDef,
    UpdateEndOfMeetingReminderTypeDef,
    UpdateGatewayGroupRequestRequestTypeDef,
    UpdateGatewayRequestRequestTypeDef,
    UpdateInstantBookingTypeDef,
    UpdateRequireCheckInTypeDef,
    UpdateNetworkProfileRequestRequestTypeDef,
    UpdateRoomRequestRequestTypeDef,
    UpdateSkillGroupRequestRequestTypeDef,
    UpdateBusinessReportScheduleRequestRequestTypeDef,
    BusinessReportTypeDef,
    PutConferencePreferenceRequestRequestTypeDef,
    ConferenceProviderTypeDef,
    UpdateConferenceProviderRequestRequestTypeDef,
    ContactDataTypeDef,
    ContactTypeDef,
    UpdateContactRequestRequestTypeDef,
    ContentTypeDef,
    CreateAddressBookRequestRequestTypeDef,
    CreateBusinessReportScheduleRequestRequestTypeDef,
    CreateConferenceProviderRequestRequestTypeDef,
    CreateContactRequestRequestTypeDef,
    CreateGatewayGroupRequestRequestTypeDef,
    CreateNetworkProfileRequestRequestTypeDef,
    CreateRoomRequestRequestTypeDef,
    CreateSkillGroupRequestRequestTypeDef,
    CreateUserRequestRequestTypeDef,
    RegisterAVSDeviceRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    CreateAddressBookResponseTypeDef,
    CreateBusinessReportScheduleResponseTypeDef,
    CreateConferenceProviderResponseTypeDef,
    CreateContactResponseTypeDef,
    CreateGatewayGroupResponseTypeDef,
    CreateNetworkProfileResponseTypeDef,
    CreateProfileResponseTypeDef,
    CreateRoomResponseTypeDef,
    CreateSkillGroupResponseTypeDef,
    CreateUserResponseTypeDef,
    GetAddressBookResponseTypeDef,
    GetConferencePreferenceResponseTypeDef,
    GetInvitationConfigurationResponseTypeDef,
    ListSkillsStoreCategoriesResponseTypeDef,
    ListTagsResponseTypeDef,
    RegisterAVSDeviceResponseTypeDef,
    SearchAddressBooksResponseTypeDef,
    SendAnnouncementResponseTypeDef,
    CreateMeetingRoomConfigurationTypeDef,
    SkillDetailsTypeDef,
    ListDeviceEventsResponseTypeDef,
    DeviceStatusInfoTypeDef,
    ListGatewayGroupsResponseTypeDef,
    GetGatewayGroupResponseTypeDef,
    ListGatewaysResponseTypeDef,
    GetGatewayResponseTypeDef,
    GetNetworkProfileResponseTypeDef,
    GetRoomResponseTypeDef,
    GetRoomSkillParameterResponseTypeDef,
    PutRoomSkillParameterRequestRequestTypeDef,
    ResolveRoomResponseTypeDef,
    GetSkillGroupResponseTypeDef,
    ListBusinessReportSchedulesRequestListBusinessReportSchedulesPaginateTypeDef,
    ListConferenceProvidersRequestListConferenceProvidersPaginateTypeDef,
    ListDeviceEventsRequestListDeviceEventsPaginateTypeDef,
    ListSkillsRequestListSkillsPaginateTypeDef,
    ListSkillsStoreCategoriesRequestListSkillsStoreCategoriesPaginateTypeDef,
    ListSkillsStoreSkillsByCategoryRequestListSkillsStoreSkillsByCategoryPaginateTypeDef,
    ListSmartHomeAppliancesRequestListSmartHomeAppliancesPaginateTypeDef,
    ListTagsRequestListTagsPaginateTypeDef,
    ListSkillsResponseTypeDef,
    ListSmartHomeAppliancesResponseTypeDef,
    MeetingRoomConfigurationTypeDef,
    SearchNetworkProfilesResponseTypeDef,
    SearchProfilesResponseTypeDef,
    SearchRoomsResponseTypeDef,
    SearchAddressBooksRequestRequestTypeDef,
    SearchContactsRequestRequestTypeDef,
    SearchDevicesRequestRequestTypeDef,
    SearchDevicesRequestSearchDevicesPaginateTypeDef,
    SearchNetworkProfilesRequestRequestTypeDef,
    SearchProfilesRequestRequestTypeDef,
    SearchProfilesRequestSearchProfilesPaginateTypeDef,
    SearchRoomsRequestRequestTypeDef,
    SearchRoomsRequestSearchRoomsPaginateTypeDef,
    SearchSkillGroupsRequestRequestTypeDef,
    SearchSkillGroupsRequestSearchSkillGroupsPaginateTypeDef,
    SearchUsersRequestRequestTypeDef,
    SearchUsersRequestSearchUsersPaginateTypeDef,
    SearchSkillGroupsResponseTypeDef,
    SearchUsersResponseTypeDef,
    UpdateMeetingRoomConfigurationTypeDef,
    BusinessReportScheduleTypeDef,
    GetConferenceProviderResponseTypeDef,
    ListConferenceProvidersResponseTypeDef,
    SearchContactsResponseTypeDef,
    GetContactResponseTypeDef,
    SendAnnouncementRequestRequestTypeDef,
    CreateProfileRequestRequestTypeDef,
    SkillsStoreSkillTypeDef,
    DeviceDataTypeDef,
    DeviceTypeDef,
    ProfileTypeDef,
    UpdateProfileRequestRequestTypeDef,
    ListBusinessReportSchedulesResponseTypeDef,
    ListSkillsStoreSkillsByCategoryResponseTypeDef,
    SearchDevicesResponseTypeDef,
    GetDeviceResponseTypeDef,
    GetProfileResponseTypeDef,
)


def get_structure() -> AddressBookDataTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers a drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-alexaforbusiness` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_alexaforbusiness/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
